/* sorgente: malloc.c */

/*
** illustra il corretto utilizzo dalle funzioni malloc() e
** free()
*/

/* inclusione del file di intestazione della libreria standard
** che contiene definizioni di macro, costanti e dichiarazioni
** di funzioni e tipi funzionali alle varie operazioni di I/O */
#include <stdio.h>

/* inclusione del file di intestazione della libreria
** standard che contiene definizioni di macro,
** costanti e dichiarazioni di funzioni di interesse generale */
#include <stdlib.h>

/*
** funzione che visualizza il contenuto di un buffer di interi
*/
void VisBuffInt(int *ptr, unsigned int nro_val)
  {
  /* definisce il cursore per la scansione del buffer */
  int curs;
  
  /* scandisce il buffer visualizzandone il contenuto */
  for (curs = 0; curs <= nro_val-1; curs++)
    printf("\nElemento %d: %d", curs, ptr[curs]);
  }
  
/* alloca, visualizza e successivamente rilascia, un buffer
** per un numero di valori interi specificato a run-time */
int main()
  {
  /* definisce le variabili per la dimensione del buffer
  ** e per il suo indirizzo iniziale */
  unsigned int nro_val;
  int *ptr;
  
  /* acquisisce la dimensione del buffer */
  printf("\nQuanti valori? ");
  scanf("%u", &nro_val);
  
  /* alloca memoria il buffer */
  ptr = (int *)malloc(nro_val * sizeof(int));
  
  /* se l'allocazione  fallita termina */
  if (ptr == NULL)
    {
    printf("\nAllocazione fallita");
    return(0);
    };
  
  /* se l'allocazione ha successo visualizza
  ** il contenuto del buffer e rilascia la memoria per
  ** questo allocata */
  printf("\nAllocazione avvenuta con successo\n");
  printf("\nContenuto del buffer: ");
  VisBuffInt(ptr, nro_val);
     
  /* rilascia la memoria allocata per il buffer */
  free(ptr);
  
  return(1);
  }
